;*************************************************************
;*	          FFT-Programm fr bis zu 128 Datenpunkte        *
;*    reelle Eingangsdaten werden "in place" transformiert   *
;*    128 Datenpunkte ergeben 64 Real/Imaginr-Datenpaare    *
;*  Programmiert von niels laugwitz fr avr-Mikrocontroller  *
;*************************************************************
;
;.device ATmega8
.include "m8def.inc" 	;Lade die Registerdefinitionen fr AT-Mega8
.DEF temprL = r2
.def temprH = r3
.DEF tempiL = r4
.def tempiH = r5
.DEF i1 = r2  	;Benutzt in for_Schleife_i 	
.def i2 = r3	;Benutzt in for_Schleife_i 	
.DEF i3 = r4	;Benutzt in for_Schleife_i 	
.def i4 = r5	;Benutzt in for_Schleife_i 	
.def sortierzeiger=r0;
.def nullwert=r6
.def jjende=r7
.def data1 = R8
.def data2 =R9
.def data3 =R10
.def data4 =R11
.def wrL=r12
.def wrH=r13
.def wiL=r14
.def wiH=r15
.DEF 	temp =r16
.DEF 	ii   =r17
.DEF	jj   =r18
.DEF    mmax =r19
.DEF	j	 =r20
.DEF	istep=r21
.def 	i	 =r22
.DEF	m	 =r23
.def  zaehler=r24
.DEF	tmp_lo  =r18	;Benutzt in for_Schleife_i 	
.DEF    tmp_hi 	=r19	;Benutzt in for_Schleife_i 	

.set	nn2 =128		;length of input-array 
;* important: 8 =< nn2 =< 128 
;* cosinetab and sinetab have to be same lenght as input-array
;* use the correct table named "speicherorte_nn2_werte" for your
;* input-array.  
.equ h1r_lo =$60
.equ h1r_hi =$61
.equ h1i_lo =$62
.equ h1i_hi =$63
.equ h2r_lo =$64
.equ h2r_hi =$65
.equ h2i_lo =$66
.equ h2i_hi =$67
.equ sramstart = $0080

.org $0000
rjmp main		;reset
.include "fft_math.asm"		;multiply,divide and sqrt-functions

;****************************************************
;******************** MAIN PROGRAM ******************
;****************************************************
main:
;initialisieren des Stacks
	ldi r16,high(RAMEND)
	out spH,r16
	ldi r16,low(RAMEND)
	out spl,r16
	sei
;*********************************************************
;* first step: re-arrange the data
;* for real applications rewrite this procedure as needed
;*********************************************************
	rcall butterfly_sort	

;****************************************
;** here starts the main FFT-loop 
;****************************************
ldi mmax,2
while_schleife_start:

cpi mmax,nn2		;nn2=32,64 or 128 
brlo while_schleife_body		;while nn2>mmax do while_schleife_body		
rjmp while_schleife_ende		;ende der while-Schleife erreicht

while_schleife_body:
mov istep,mmax
lsl istep			;istep:=2*mmax
clr ii				;ii:=0
for_schleife_ii_start:    ;for ii=1 to (mmax div 2)
	inc ii						
	mov m,ii
	lsl m			;m:=2*ii
	dec m			;m:=2*ii-1
	ldi temp,nn2		
	sub temp,m			;nn2-m
	mov dd8u,temp
	mov dv8u,istep
	rcall div8u			;Divisionsroutine 
;.def	drem8u	=r15		;remainder
;.def	dres8u	=r24		;result
;.def	dd8u	=r24		;dividend
;.def	dv8u	=r25		;divisor
	mov jjende,dres8u		;jjende:=nn2-m div istep
	clr jj					;jj:=0  Initialisierung fr Schleife
;Nun holen wir die Cosinuswerte 
	ldi ZH,high(2*cosinetab)
	ldi ZL, low(2*cosinetab)
	ldi zaehler,nn2
	mov temp,mmax
	lsr temp
pp: lsr zaehler
	lsr temp
	brne pp
	mov temp,ii
	dec temp
	mul temp,zaehler
	add ZL,r0
	adc ZH,r1
	add ZL,r0	;addition des pointers doppelt wegen 	
	adc ZH,r1	;2Byte pro Tabelleneintrag	
	lpm wrL,Z+	;jetzt haben wir wrL(ow)
	lpm wrH,Z	;jetzt haben wir wrH(igh)
;Nun holen wir die Sinuswerte 
	ldi ZH,high(2*sinetab)
	ldi ZL, low(2*sinetab)
	ldi zaehler,nn2
	mov temp,mmax
	lsr temp
pq: lsr zaehler
	lsr temp
	brne pq
	mov temp,ii
	dec temp
	mul temp,zaehler
	add ZL,r0
	adc ZH,r1
	add ZL,r0	;Addition des Pointer-Werts doppelt wegen 	
	adc ZH,r1	;2Byte pro Tabelleneintrag	
	lpm wiL,Z+	;jetzt haben wir wiL(ow)
	lpm wiH,Z	;jetzt haben wir wiH(igh)
for_schleife_jj_start:
		rcall Schleife_jj_body	;damit die Schleife mit einer branch-instruktion
								;abgeschlossen werden kann, wird die eigentliche 
								;Abarbeitungsroutine mit rcall aufgerufen. 
								;(Problem ist die Sprungreichweite von brsh)
		inc jj
		cp jjende,jj
		brsh for_schleife_jj_start	
;ende der jj-Schleife
	mov temp,mmax
	lsr temp  		;iiende:=mmax div 2
	cp ii,temp				
	brlo for_schleife_ii_start
;hier ist das ende der for_schleife_ii
mov mmax,istep
rjmp while_schleife_start
While_schleife_ende:
;******************************************************************
;* FFT is nearly done. We begun with real input data, so we need an      
;* additional loop to get correct results. This could be spared
;* if we started with complex input values. But who needs this?
;****************************************************************** 
ldi i,1		;Initialisierung von i
for_schleife_i_anfang:
	inc i		;for i:=2 to ((nn2 div 4)+1)
;Berechnung der Indizes i1..i4 
	mov i1,i
	lsl i1		
	dec i1			; i1:=i+i-1
	mov i2,i1
	inc i2			; i2:= i1+1
	ldi temp,nn2
	sub temp,i2
	subi temp,-3		
	mov i3,temp 	; i3:=nn2-i2+3
	mov i4,i3
	inc i4			; i4:=i3+1
;Nun holen wir die wr
	ldi ZH,high(2*cosinetab)
	ldi ZL, low(2*cosinetab)
	mov temp,i
	dec temp
	lsl temp
	add ZL,temp
	adc ZH,nullwert
	lpm wrL,Z+	;jetzt haben wir wrL(ow)
	lpm wrH,Z	;jetzt haben wir wrH(igh)
;Nun holen wir die wi
	ldi ZH,high(2*sinetab)
	ldi ZL, low(2*sinetab)
	mov temp,i
	dec temp
	lsl temp
	add ZL,temp
	adc ZH,nullwert
	lpm wiL,Z+	;jetzt haben wir wiL(ow)
	lpm wiH,Z	;jetzt haben wir wiH(igh)
	rcall for_schleife_calculus		;auch hier Unterprogramm, damit die
									;Schleife mit brlo enden kann.
;test ob FOR_Schleife schon fertig
	ldi temp,nn2
	lsr temp
	lsr temp
	inc temp
	cp i,temp
	brlo for_schleife_i_anfang
for_schleife_i_exit:			;Umsortieren ist geschafft.
nop
;here comes extra calcualtion for DC-Value (f_0) and f(N/2).
rcall DC_compensation 
;****************************************************************
;* Now the fft is done. Data-array (starts at sramstart+2) 
;* contains real-part and imaginary-part as 16bit values (lo:hi)
;* arranged in pairs first real, then imaginary part.
;* special case occurs at the beginning: first real-value ist f_0
;* and first imag data point represents f(N/2) as real-value
;* NOTE: f_0 & f(N/2) are always real values & never complex data
;****************************************************************
ende:			;fine!
rjmp ende		;SCHLUSS! ENDE! AUS!	

;***********************************************************
;***********************************************************
;** here are the subroutines *******************************
;***********************************************************
;***********************************************************

butterfly_sort:
;Kopieren der Test-Daten ins SRAM
;Testdaten werden als 16-bit-signed abgespeichert(-16384 ...+16384). 
;Die FFT ergibt ebenfalls 16-bit Daten 
ldi ZH,high(2*testdata)
ldi ZL, low(2*testdata)
clr i
blockkopieren:	;Das Kopieren der Werte erspart mir eine 
				;butterfly-sort zu programmieren, simple stupid!	
LPM data1,Z+	;Lade Werte aus der Ursprungstabelle testdata
LPM data2,Z+
push ZH
push ZL
ldi ZH,high(2*speicherorte_128_werte)		;for nn2 <> 128 use
ldi ZL, low(2*speicherorte_128_werte)		;appropriate table 
add ZL,i
adc ZH,nullwert
lpm sortierzeiger,Z	;get the position, at which to save the data-point
pop ZL
pop ZH
ldi XH,0
ldi XL,sramstart
add XL,sortierzeiger
adc XH,nullwert
add XL,sortierzeiger
adc XH,nullwert
st X+,data1		;speichere lower-Byte zuerst
st X,data2		;Highbyte 
				;speichere alle Daten umsortiert im SRAM
inc i
cpi i,nn2
brne blockkopieren
;nun sind die daten fr die FFT umsortiert und stehen im SRAM ab 
;Adresse (sramstart+2)=$0082. Fr Eigene Anwendungen sollten die Daten  
;von Anfang an nach der Sortiertabelle "speicherorte_XX_werte" geordnet 
;werden. Die Werte sind im SRAM abgelegt als 16 bit signed integer!
;dw = LOW:HIGH 
ret
;*********** end of butterfly-sort ************

;************* subroutine for-loop jj *****************
schleife_jj_body:
;Berechnung der Indexe i und j:
		mov i,m
		mul	jj,istep	;r0 := jj*istep
		mov i,r0			
		add i,m			;i:=m+jj*istep
		mov temp,i
		add temp,mmax
		mov j,temp		;j:=i+mmax
;Hole data[j] und data[j+1] aus dem SRAM 
		ldi XH,0
		ldi XL,sramstart
		add XL,j		
		adc XH,nullwert ;da das Array Data als 16bit-Werte abgespeichert ist,
		add XL,j		;muss der Index verdoppelt werden. 
		adc XH,nullwert 
		ld data1,X+		;hole Data[j]low-byte
		ld data2,X+		;hole Data[j]High-byte
		ld data3,X+		;Hole Data[j+1]low-Byte
		ld data4,X		;hole Data[j+1]High-Byte
;Berechne tempr und tempi mehrere Multiplikationen erfordern 
;etwas platz in den oberen registern. Im Moment brauchen wir die
; nicht: Also ab auf den Stack!
		push r23
		push r22
		push r21
		push r20
		push r19
		push r18
		push r17
		push r16
;Berechne tempr
		movw r21:r20,wrh:wrl
		movw r23:r22,data2:data1
		rcall muls16x16_32 ;tempr:=wr*data[j] (16bit signed)
		MOV temprH,r19	;we take just the high-result-bytes	
		MOV temprL,r18	
		movw r21:r20,wih:wil
		movw r23:r22,data4:data3
		rcall muls16x16_32 ;tempi:=wi*data[j+1] (16bit signed)
		MOV tempiH,r19		;we take just the HIGH-result-bytes	
		MOV tempiL,r18	
		sub temprL,tempiL
		sbc temprH,tempiH		;tempr := wr*data[j]-wi*data[j+1] 	
;Berechne tempi
		push temprL			
		push temprH
		movw r21:r20,wrh:wrl
		movw r23:r22,data4:data3
		rcall muls16x16_32 		;tempr:=wr*data[j+1] (16bit signed)
		MOV temprH,r19	;we take just the HIGH-result-bytes	
		MOV temprL,r18	
		movw r21:r20,wih:wil
		movw r23:r22,data2:data1
		rcall muls16x16_32 ;tempi:=wi*data[j] (16bit signed)
		MOV tempiH,r19	;we take just the hi-result-bytes	
		MOV tempiL,r18	
		add tempiL,temprL
		adc tempiH,temprH		;tempi := wr*data[j+1]+wi*data[j] 	
		pop temprH
		pop temprL
		pop r16
		pop r17
		pop r18
		pop r19
		pop r20
		pop r21
		pop r22
		pop r23
;multiplikationen beendet, Stack und Register wieder in Ordnung

;Hole data[i] aus dem SRAM 
		ldi XH,0
		ldi XL,sramstart
		add XL,i
		adc XH,nullwert
		add XL,i
		adc XH,nullwert
		ld data3,X+		;hole Data[i]Low-Byte
		ld data4,X		;Hole Data[i]high-Byte
;data[j]:=data[i]-tempr
		movw data2:data1, data4:data3
		asr data2
		ror data1
		sub data1,temprL
		sbc data2,temprH
		ldi XH,0
		ldi XL,sramstart
		add XL,j
		adc XH,nullwert
		add XL,j
		adc XH,nullwert
		st X+,data1
		st X,data2
;Hole data[i+1] aus dem SRAM 
		ldi XH,0
		ldi XL,sramstart
		add XL,i
		adc XH,nullwert
		add XL,i
		adc XH,nullwert
		adiw XH:XL,2
		ld data3,X+		;hole Data[i+1]low-Byte
		ld data4,X		;Hole Data[i+1]high-Byte
;data[j+1]:=data[i+1]-tempi
		movw data2:data1, data4:data3
		asr data2
		ror data1
		sub data1,tempiL
		sbc data2,tempiH
		ldi XH,0
		ldi XL,sramstart
		add XL,j
		adc XH,nullwert
		add XL,j
		adc XH,nullwert
		adiw XH:XL,2
		st X+,data1
		st X,data2
;data[i+1]:=data[i+1]+tempi
		asr data4
		ror data3
		add data3,tempiL
		adc data4,tempiH
		ldi XH,0
		ldi XL,sramstart
		add XL,i
		adc XH,nullwert
		add XL,i
		adc XH,nullwert
		adiw XH:XL,2
		st X+,data3
		st X,data4
;Hole data[i] aus dem SRAM 
		ldi XH,0
		ldi XL,sramstart
		add XL,i
		adc XH,nullwert
		add XL,i
		adc XH,nullwert
		ld data3,X+		;hole Data[i]low-Byte
		ld data4,X		;Hole Data[i]high-Byte
;data[i]:=data[i]+tempr
		asr data4
		ror data3
		add data3,temprL
		adc data4,temprH
		ldi XH,0
		ldi XL,sramstart
		add XL,i
		adc XH,nullwert
		add XL,i
		adc XH,nullwert
		st X+,data3
		st X,data4
		ret		;Rcksprung zur Schleife_jj

for_schleife_calculus:
;***** Berechnung von h1r und h2i
;hole Data[i1] in reg. data2:data1
	ldi XH,0
	ldi XL,sramstart
	add XL,i1
	adc XH,nullwert
	add XL,i1
	adc XH,nullwert
	ld data1,X+		;lower-Byte zuerst
	ld data2,X		;Highbyte 
;hole Data[i3] in register-pair data4:data3
	ldi XH,0
	ldi XL,sramstart
	add XL,i3
	adc XH,nullwert
	add XL,i3
	adc XH,nullwert
	ld data3,X+		;lower-Byte zuerst
	ld data4,X		;Highbyte 
	asr data2
	ror data1		;data[i1]:=data[i1]/2
	asr data4
	ror data3		;data[i3]:=data[i3]/2
	movw tmp_hi:tmp_lo,data2:data1
	add tmp_lo,data3
	adc tmp_hi,data4		;h1r:=data[i1]+data[i3]
	sts h1r_lo,tmp_lo
	sts h1r_hi,tmp_hi		;save h1r to sram-location
	movw tmp_hi:tmp_lo,data2:data1
	sub tmp_lo,data3
	sbc tmp_hi,data4		;h1r:=-1*(data[i1]-data[i3])
	com tmp_lo
	com tmp_hi 
	ldi temp,1
	add tmp_lo,temp
	adc tmp_hi,nullwert
	sts h2i_lo,tmp_lo
	sts h2i_hi,tmp_hi		;save h1r to sram-location
;***** Berechnung von h1i und h2r
;hole Data[i2] in reg. data2:data1
	ldi XH,0
	ldi XL,sramstart
	add XL,i2
	adc XH,nullwert
	add XL,i2
	adc XH,nullwert
	ld data1,X+		;lower-Byte zuerst
	ld data2,X		;Highbyte 
;hole Data[i4] in register-pair data4:data3
	ldi XH,0
	ldi XL,sramstart
	add XL,i4
	adc XH,nullwert
	add XL,i4
	adc XH,nullwert
	ld data3,X+		;lower-Byte zuerst
	ld data4,X		;Highbyte 
	asr data2
	ror data1		;data[i2]:=data[i2]/2
	asr data4
	ror data3		;data[i4]:=data[i4]/2
	movw tmp_hi:tmp_lo,data2:data1
	sub tmp_lo,data3
	sbc tmp_hi,data4		
	sts h1i_lo,tmp_lo
	sts h1i_hi,tmp_hi		;save h1i to sram-location
	add data1,data3
	adc data2,data4		
	sts h2r_lo,data1
	sts h2r_hi,data2		;save h2r to sram-location
		push r23
		push r22
		push r21
		push r20
		push r19
		push r18
		push r17
		push r16
; **** Data[i1]:=h1r+wr*h2r-wi*h2i
		movw R21:R20,wrh:wrl
		lds r23,h2r_hi
		lds r22,h2r_lo
		rcall muls16x16_32
			rol r17
			rol r18
			rol r19
		mov data2,r19
		mov data1,r18
		movw R21:R20,wih:wil
		lds r23,h2i_hi
		lds r22,h2i_lo
		rcall muls16x16_32
			rol r17
			rol r18
			rol r19
		sub data1,r18
		sbc data2,r19
		lds r18,h1r_hi
		lds r17,h1r_lo
		add data1,r17
		adc data2,r18
		ldi XH,0
		ldi XL,sramstart
		add XL,i1
		adc XH,nullwert
		add XL,i1
		adc XH,nullwert
		st X+,data1
		st X ,data2
; **** Data[i2]:=h1i+wr*h2i+wi*h2r
		movw R21:R20,wrh:wrl
		lds r23,h2i_hi
		lds r22,h2i_lo
		rcall muls16x16_32
			rol r17
			rol r18
			rol r19
		mov data2,r19
		mov data1,r18
		movw R21:R20,wih:wil
		lds r23,h2r_hi
		lds r22,h2r_lo
		rcall muls16x16_32
			rol r17
			rol r18
			rol r19
		add data1,r18
		adc data2,r19
		lds r18,h1i_hi
		lds r17,h1i_lo
		add data1,r17
		adc data2,r18
		ldi XH,0
		ldi XL,sramstart
		add XL,i2
		adc XH,nullwert
		add XL,i2
		adc XH,nullwert
		st X+,data1
		st X ,data2
; **** Data[i3]:=h1r-wr*h2r+wi*h2i
		movw R21:R20,wih:wil
		lds r23,h2i_hi
		lds r22,h2i_lo
		rcall muls16x16_32
			rol r17
			rol r18
			rol r19
		mov data2,r19
		mov data1,r18
		movw R21:R20,wrh:wrl
		lds r23,h2r_hi
		lds r22,h2r_lo
		rcall muls16x16_32
			rol r17
			rol r18
			rol r19
		sub data1,r18
		sbc data2,r19
		lds r18,h1r_hi
		lds r17,h1r_lo
		add data1,r17
		adc data2,r18
		ldi XH,0
		ldi XL,sramstart
		add XL,i3
		adc XH,nullwert
		add XL,i3
		adc XH,nullwert
		st X+,data1
		st X ,data2
; **** Data[i4]:=-h1i+wr*h2i+wi*h2r
		movw R21:R20,wrh:wrl
		lds r23,h2i_hi
		lds r22,h2i_lo
		rcall muls16x16_32
			rol r17
			rol r18
			rol r19
		mov data2,r19
		mov data1,r18
		movw R21:R20,wih:wil
		lds r23,h2r_hi
		lds r22,h2r_lo
		rcall muls16x16_32
			rol r17
			rol r18
			rol r19
		add data1,r18
		adc data2,r19
		lds r18,h1i_hi
		lds r17,h1i_lo
		sub data1,r17
		sbc data2,r18
		ldi XH,0
		ldi XL,sramstart
		add XL,i4
		adc XH,nullwert
		add XL,i4
		adc XH,nullwert
		st X+,data1
		st X ,data2
		pop r16
		pop r17
		pop r18
		pop r19
		pop r20
		pop r21
		pop r22
		pop r23
	ret		;ende der umfangreichen Berechnungen in For_schleife_i

DC_compensation:
		lds data1,sramstart+2
		lds data2,sramstart+3
		lds data3,sramstart+4
		lds data4,sramstart+5
		movw tmp_hi:tmp_lo,data2:data1
		add data1,data3
		adc data2,data4
		sub tmp_lo,data3
		sbc tmp_hi,data4
		asr data4
		ror data3
		asr tmp_hi
		ror tmp_lo
		sts sramstart+2,data1
		sts sramstart+3,data2
		sts sramstart+4,tmp_lo
		sts sramstart+5,tmp_hi
	ret
;ende DC-kompensation

sinetab:
.dw 	0, 1608, 3212, 4808, 6393, 7962, 9512,11039
.dw 12539,14010,15446,16846,18204,19519,20787,22005
.dw 23170,24279,25329,26319,27245,28105,28898,29621
.dw 30273,30852,31356,31785,32137,32412,32609,32728
cosinetab:
.dw 32767,32728,32609,32412,32137,31785,31356,30852
.dw 30273,29621,28898,28105,27245,26319,25329,24279
.dw 23170,22005,20787,19519,18204,16846,15446,14010
.dw 12539,11039, 9512, 7962, 6393, 4808, 3212, 1608
.dw 	0,-1608,-3212,-4808,-6393,-7962,-9512,-11039
.dw -12539,-14010,-15446,-16846,-18204,-19519,-20787,-22005
.dw -23170,-24279,-25329,-26319,-27245,-28105,-28898,-29621
.dw -30273,-30852,-31356,-31785,-32137,-32412,-32609,-32728
.dw -32767,-32728,-32609,-32412,-32137,-31785,-31356,-30852
.dw -30273,-29621,-28898,-28105,-27245,-26319,-25329,-24279
.dw -23170,-22005,-20787,-19519,-18204,-16846,-15446,-14010
.dw -12539,-11039,-9512,-7962,-6393,-4808,-3212,-1608
.dw 	0, 1608, 3212, 4808, 6393, 7962, 9512,11039
.dw 12539,14010,15446,16846,18204,19519,20787,22005
.dw 23170,24279,25329,26319,27245,28105,28898,29621
.dw 30273,30852,31356,31785,32137,32412,32609,32728

testdata:		;128 Datapoints (values can range from -16384 to +16384)
				;all values treated als signed integer
				;keeping all values within this range avoids overflows 
.dw		-16000,-14000,-12000,-10000, -8000, -6000, -4000, -2000
.dw			 0,  2000,  4000,  6000,  8000, 10000, 12000, 14000
.dw		-16000,-14000,-12000,-10000, -8000, -6000, -4000, -2000
.dw			 0,  2000,  4000,  6000,  8000, 10000, 12000, 14000
.dw		-16000,-14000,-12000,-10000, -8000, -6000, -4000, -2000
.dw			 0,  2000,  4000,  6000,  8000, 10000, 12000, 14000
.dw		-16000,-14000,-12000,-10000, -8000, -6000, -4000, -2000
.dw			 0,  2000,  4000,  6000,  8000, 10000, 12000, 14000
.dw		-16000,-14000,-12000,-10000, -8000, -6000, -4000, -2000
.dw			 0,  2000,  4000,  6000,  8000, 10000, 12000, 14000
.dw		-16000,-14000,-12000,-10000, -8000, -6000, -4000, -2000
.dw			 0,  2000,  4000,  6000,  8000, 10000, 12000, 14000
.dw		-16000,-14000,-12000,-10000, -8000, -6000, -4000, -2000
.dw			 0,  2000,  4000,  6000,  8000, 10000, 12000, 14000
.dw		-16000,-14000,-12000,-10000, -8000, -6000, -4000, -2000
.dw			 0,  2000,  4000,  6000,  8000, 10000, 12000, 14000

speicherorte_128_werte:
.db	1,2
.db	65,66
.db	33,34
.db	97,98
.db	17,18
.db	81,82
.db	49,50
.db	113,114
.db	9,10
.db	73,74
.db	41,42
.db	105,106
.db	25,26
.db 89,90
.db	57,58
.db	121,122
.db	5,6
.db	69,70
.db	37,38
.db	101,102
.db	21,22
.db	85,86
.db	53,54
.db	117,118
.db	13,14
.db	77,78
.db	45,46
.db	109,110
.db	29,30
.db	93,94
.db	61,62
.db	125,126
.db	3,4
.db	67,68
.db	35,36
.db	99,100
.db	19,20
.db	83,84
.db	51,52
.db	115,116
.db	11,12
.db	75,76
.db	43,44
.db	107,108
.db	27,28
.db	91,92
.db	59,60
.db	123,124
.db	7,8
.db	71,72
.db	39,40
.db	103,104
.db	23,24
.db	87,88
.db	55,56
.db	119,120
.db	15,16
.db	79,80
.db	47,48
.db	111,112
.db	31,32
.db	95,96
.db	63,64
.db	127,128

speicherorte_64_werte:		;Sortiertabelle fr 64 Werte
.db	      1,      2,     33,     34
.db      17,     18,     49,     50
.db       9,     10,     41,     42
.db      25,     26,     57,     58
.db       5,      6,     37,     38
.db      21,     22,     53,     54
.db      13,     14,     45,     46
.db      29,     30,     61,     62
.db       3,      4,     35,     36
.db      19,     20,     51,     52
.db      11,     12,     43,     44
.db      27,     28,     59,     60
.db       7,      8,     39,     40
.db      23,     24,     55,     56
.db      15,     16,     47,     48
.db      31,     32,     63,     64
;*********************

speicherorte_32_werte:		;Sortiertabelle fr 32 Werte
.db       1,      2,     17,     18
.db       9,     10,     25,     26
.db       5,      6,     21,     22
.db      13,     14,     29,     30
.db       3,      4,     19,     20
.db      11,     12,     27,     28
.db       7,      8,     23,     24
.db      15,     16,     31,     32
